#include "Buffer.h"

#include <cstring>

using byte = uint8_t;

namespace Feather::Network
{

    int Buffer::WriteVarInt(int value)
    {
        int size = 0;
        do {
            byte temp = (byte)(value & 0b01111111);
            // Note: >>> means that the sign bit is shifted with the rest of the number rather than being left alone
            value >>= 7;
            if (value != 0) {
                temp |= 0b10000000;
            }
            WriteByte(temp);
            size++;
        } while (value != 0);

        return size;
    }

    void Buffer::WriteString(const char* str)
    {
        WriteString(str, strlen(str));
    }

    void Buffer::WriteString(const char *str, size_t length)
    {
        WriteVarInt(length);
        for (int i = 0; i < length; i++)
            WriteByte(str[i]);
    }
}